Package org.eclipse.osgi.service.resolver

## Interface GenericDescription

All Superinterfaces:
  `BaseDescription`

    public interface GenericDescription
    extends BaseDescription

A description of a generic capability.

Since:
  3.2
Restriction:
  This interface is not intended to be implemented by clients.

### Field Summary

Fields
`static String` `DEFAULT_TYPE` The default type of generic capability.

### Method Summary

All Methods Instance Methods Abstract Methods Deprecated Methods
`Dictionary<String,​Object>` `getAttributes()` Returns the arbitrary attributes for this description
`String` `getName()` Deprecated. matching should only be done against a capability's attributes.
`String` `getType()` Returns the type of generic description capability
`Version` `getVersion()` Deprecated. matching should only be done against a capability's attributes.

### Methods inherited from interface org.eclipse.osgi.service.resolver.BaseDescription

`getCapability, getDeclaredAttributes, getDeclaredDirectives, getSupplier, getUserObject, setUserObject`

### Field Detail

#### DEFAULT_TYPE

    static final String DEFAULT_TYPE

The default type of generic capability.

See Also:
  Constant Field Values

### Method Detail

#### getAttributes

    Dictionary<String,​Object> getAttributes()

Returns the arbitrary attributes for this description

Returns:
  the arbitrary attributes for this description

#### getType

    String getType()

Returns the type of generic description capability

Returns:
  the type of generic description capability

#### getName

    String getName()

Deprecated.
matching should only be done against a capability's attributes.
This method is deprecated. Capabilities do not always have a name associated with them. All matching attributes associated with a capability are available in the attributes of a capability. This method will return the value of the attribute with the same key as this capabilities type. If this attribute's value is not a String then null is returned.

Specified by:
  `getName` in interface `BaseDescription`
Returns:
  the name

#### getVersion

    Version getVersion()

Deprecated.
matching should only be done against a capability's attributes.
This method is deprecated. Capabilities do not always have a version associated with them. All matching attributes associated with a capability are available in the attributes of a capability. This method will return the value of the attribute with the key `"version"`. If this attribute's value is not a `Version` then null is returned.

Specified by:
  `getVersion` in interface `BaseDescription`
Returns:
  the version